precision mediump float;

varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform float minLevel;
uniform float midLevel;//akaGamma
uniform float maxLevel;

float calcCol(float color, float gamma)
{
    color -= minLevel;
    color = (pow(color, gamma))/(maxLevel - minLevel);

    return clamp(color, 0.0, 1.0);
}

void main()
{
    vec4 color = texture2D(inputImageTexture, textureCoordinate);

    float f = pow(10.0, midLevel);
    gl_FragColor = vec4(calcCol(color.r, f), calcCol(color.g, f), calcCol(color.b, f), color.a);
}
